package dev.shadowsoffire.apotheosis.adventure.client;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.blaze3d.vertex.PoseStack;
import com.mojang.blaze3d.vertex.Tesselator;
import com.mojang.datafixers.util.Either;
import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.adventure.Adventure;
import dev.shadowsoffire.apotheosis.adventure.AdventureConfig;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixRegistry;
import dev.shadowsoffire.apotheosis.adventure.affix.augmenting.AugmentingTableTileRenderer;
import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingTableTileRenderer;
import dev.shadowsoffire.apotheosis.adventure.client.AdventureKeys;
import dev.shadowsoffire.apotheosis.adventure.client.BossSpawnMessage;
import dev.shadowsoffire.apotheosis.adventure.client.SocketTooltipRenderer;
import dev.shadowsoffire.apotheosis.adventure.socket.SocketHelper;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance;
import dev.shadowsoffire.attributeslib.api.client.AddAttributeTooltipsEvent;
import dev.shadowsoffire.attributeslib.api.client.GatherSkippedAttributeTooltipsEvent;
import dev.shadowsoffire.placebo.codec.CodecProvider;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import java.util.function.Consumer;
import net.minecraft.ChatFormatting;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.screens.MenuScreens;
import net.minecraft.client.player.LocalPlayer;
import net.minecraft.client.renderer.MultiBufferSource;
import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.renderer.blockentity.BeaconRenderer;
import net.minecraft.client.renderer.blockentity.BlockEntityRenderer;
import net.minecraft.client.renderer.blockentity.BlockEntityRendererProvider;
import net.minecraft.client.renderer.blockentity.BlockEntityRenderers;
import net.minecraft.client.resources.language.I18n;
import net.minecraft.client.resources.sounds.SimpleSoundInstance;
import net.minecraft.client.resources.sounds.SoundInstance;
import net.minecraft.client.sounds.SoundManager;
import net.minecraft.core.BlockPos;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.ComponentContents;
import net.minecraft.network.chat.FormattedText;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.network.chat.contents.LiteralContents;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.sounds.SoundSource;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.inventory.tooltip.TooltipComponent;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.phys.Vec3;
import net.minecraftforge.client.event.RenderLevelStageEvent;
import net.minecraftforge.client.event.RenderTooltipEvent;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.TickEvent;
import net.minecraftforge.event.entity.player.ItemTooltipEvent;
import net.minecraftforge.eventbus.api.EventPriority;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import org.apache.commons.lang3.mutable.MutableInt;

public class AdventureModuleClient {
  public static List<BossSpawnMessage.BossSpawnData> BOSS_SPAWNS = new ArrayList<>();
  
  public static void init() {
    MinecraftForge.EVENT_BUS.register(dev.shadowsoffire.apotheosis.adventure.client.AdventureModuleClient.class);
    MenuScreens.m_96206_((MenuType)Adventure.Menus.REFORGING.get(), dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingScreen::new);
    MenuScreens.m_96206_((MenuType)Adventure.Menus.SALVAGE.get(), dev.shadowsoffire.apotheosis.adventure.affix.salvaging.SalvagingScreen::new);
    MenuScreens.m_96206_((MenuType)Adventure.Menus.GEM_CUTTING.get(), dev.shadowsoffire.apotheosis.adventure.socket.gem.cutting.GemCuttingScreen::new);
    MenuScreens.m_96206_((MenuType)Adventure.Menus.AUGMENTING.get(), dev.shadowsoffire.apotheosis.adventure.affix.augmenting.AugmentingScreen::new);
    BlockEntityRenderers.m_173590_((BlockEntityType)Apoth.Tiles.REFORGING_TABLE.get(), k -> new ReforgingTableTileRenderer());
    BlockEntityRenderers.m_173590_((BlockEntityType)Apoth.Tiles.AUGMENTING_TABLE.get(), k -> new AugmentingTableTileRenderer());
    MinecraftForge.EVENT_BUS.register(AdventureKeys.class);
  }
  
  public static void onBossSpawn(BlockPos pos, float[] color) {
    BOSS_SPAWNS.add(new BossSpawnMessage.BossSpawnData(pos, color, new MutableInt()));
    SoundManager sm = Minecraft.m_91087_().m_91106_();
    for (SoundEvent soundEvent : AdventureConfig.bossAnnounceSounds)
      sm.m_120367_((SoundInstance)new SimpleSoundInstance(soundEvent, SoundSource.HOSTILE, AdventureConfig.bossAnnounceVolume, 1.25F, (Minecraft.m_91087_()).f_91074_.m_217043_(), (Minecraft.m_91087_()).f_91074_.m_20183_())); 
  }
  
  @SubscribeEvent
  public static void render(RenderLevelStageEvent e) {
    if (e.getStage() != RenderLevelStageEvent.Stage.AFTER_TRIPWIRE_BLOCKS)
      return; 
    PoseStack stack = e.getPoseStack();
    MultiBufferSource.BufferSource buf = MultiBufferSource.m_109898_(Tesselator.m_85913_().m_85915_());
    LocalPlayer localPlayer = (Minecraft.m_91087_()).f_91074_;
    for (int i = 0; i < BOSS_SPAWNS.size(); i++) {
      BossSpawnMessage.BossSpawnData data = BOSS_SPAWNS.get(i);
      stack.m_85836_();
      float partials = e.getPartialTick();
      Vec3 vec = Minecraft.m_91087_().m_91288_().m_20299_(partials);
      stack.m_85837_(-vec.f_82479_, -vec.f_82480_, -vec.f_82481_);
      stack.m_252880_(data.pos().m_123341_(), data.pos().m_123342_(), data.pos().m_123343_());
      BeaconRenderer.m_112184_(stack, (MultiBufferSource)buf, BeaconRenderer.f_112102_, partials, 1.0F, localPlayer.m_9236_().m_46467_(), 0, 64, data.color(), 0.166F, 0.33F);
      stack.m_85849_();
    } 
    buf.m_109911_();
  }
  
  @SubscribeEvent
  public static void time(TickEvent.ClientTickEvent e) {
    if (e.phase != TickEvent.Phase.END)
      return; 
    for (int i = 0; i < BOSS_SPAWNS.size(); i++) {
      BossSpawnMessage.BossSpawnData data = BOSS_SPAWNS.get(i);
      if (data.ticks().getAndIncrement() > 400)
        BOSS_SPAWNS.remove(i--); 
    } 
  }
  
  @SubscribeEvent(priority = EventPriority.HIGH)
  public static void tooltips(AddAttributeTooltipsEvent e) {
    ItemStack stack = e.getStack();
    ListIterator<Component> it = e.getAttributeTooltipIterator();
    int sockets = SocketHelper.getSockets(stack);
    if (sockets > 0)
      it.add(Component.m_237113_("APOTH_REMOVE_MARKER")); 
  }
  
  @SubscribeEvent
  public static void ignoreSocketUUIDS(GatherSkippedAttributeTooltipsEvent e) {
    ItemStack stack = e.getStack();
    for (GemInstance gem : SocketHelper.getGems(stack)) {
      Objects.requireNonNull(e);
      gem.getUUIDs().forEach(e::skipUUID);
    } 
  }
  
  @SubscribeEvent
  public static void comps(RenderTooltipEvent.GatherComponents e) {
    int sockets = SocketHelper.getSockets(e.getItemStack());
    if (sockets == 0)
      return; 
    List<Either<FormattedText, TooltipComponent>> list = e.getTooltipElements();
    int rmvIdx = -1;
    for (int i = 0; i < list.size(); i++) {
      Optional<FormattedText> o = ((Either)list.get(i)).left();
      if (o.isPresent()) {
        Component component = (Component)o.get();
        if (component instanceof Component) {
          Component comp = component;
          ComponentContents componentContents = comp.m_214077_();
          if (componentContents instanceof LiteralContents) {
            LiteralContents tc = (LiteralContents)componentContents;
            if ("APOTH_REMOVE_MARKER".equals(tc.f_237368_())) {
              rmvIdx = i;
              list.remove(i);
              break;
            } 
          } 
        } 
      } 
    } 
    if (rmvIdx == -1)
      return; 
    e.getTooltipElements().add(rmvIdx, Either.right(new SocketTooltipRenderer.SocketComponent(e.getItemStack(), SocketHelper.getGems(e.getItemStack()))));
  }
  
  @SubscribeEvent(priority = EventPriority.HIGH)
  public static void affixTooltips(ItemTooltipEvent e) {
    ItemStack stack = e.getItemStack();
    if (stack.m_41782_()) {
      Map<DynamicHolder<? extends Affix>, AffixInstance> affixes = AffixHelper.getAffixes(stack);
      List<Component> components = new ArrayList<>();
      Consumer<Component> dotPrefixer = afxComp -> components.add(Component.m_237110_("text.apotheosis.dot_prefix", new Object[] { afxComp }).m_130940_(ChatFormatting.YELLOW));
      affixes.values().stream()
        .sorted(Comparator.comparingInt(a -> ((Affix)a.affix().get()).getType().ordinal()))
        .map(AffixInstance::getDescription)
        .filter(c -> (c.m_214077_() != ComponentContents.f_237124_))
        .forEach(dotPrefixer);
      e.getToolTip().addAll(1, components);
    } 
  }
  
  public static RenderType gray(ResourceLocation texture) {
    return CustomRenderTypes.GRAY.apply(texture);
  }
  
  public static void checkAffixLangKeys() {
    StringBuilder sb = new StringBuilder("Missing Affix Lang Keys:\n");
    boolean any = false;
    String json = "\"%s\": \"\",";
    for (Affix a : AffixRegistry.INSTANCE.getValues()) {
      ResourceLocation id = AffixRegistry.INSTANCE.getKey((CodecProvider)a);
      if (!I18n.m_118936_("affix." + id)) {
        sb.append(json.formatted(new Object[] { "affix." + id }) + "\n");
        any = true;
      } 
      if (!I18n.m_118936_("affix." + id + ".suffix")) {
        sb.append(json.formatted(new Object[] { "affix." + id + ".suffix" }) + "\n");
        any = true;
      } 
    } 
    if (any)
      AdventureModule.LOGGER.error(sb.toString()); 
  }
}
